#include "p4connection.h"

#include "p4commandrunner.h"

P4Connection::P4Connection(QVariantMap config, QString conName, P4Api* p)
{
    m_P4Api = p;

      if (config.keys().contains("port"))
        m_port = config.value("port").toString();

    if (config.keys().contains("user"))
        m_user = config.value("user").toString();

    if (config.keys().contains("client"))
        m_client = config.value("client").toString();

    if (config.keys().contains("charset"))
        m_charset = config.value("charset").toString();

    m_name = conName;
}

void P4Connection::destroy()
{
    m_P4Api->destroyConnection(m_name);
}

QVariant P4Connection::_run(QVariantList cmd)
{
    P4CommandRunner* cmdRunner = new P4CommandRunner(this,cmd);

    QVariant resp = cmdRunner->exec();

    destroyBGRunner(cmdRunner);

    return resp;
}

QObject* P4Connection::_createBGRunner(QVariantList cmd)
{
    return new P4CommandRunner(this,cmd);
}

void P4Connection::destroyBGRunner(QObject* runner) {
    delete runner;
}
